
countdown=0
--setup function
function mission_start()
--replacing functions
cc.shieldgen.gen.removeshields=removeshields
cc.heli.object.move=helimove
cc.heli.object.damage=helidamage
cc.heli.bullet.move=bulletmove
cc.heli.rocket.move=rocketmove
playercontrol(0)
level_start()
end

--update function
function mission_update()
  if (getframe()%5)==0 then
         -- add all enemies + hostages + strawdummies
    enemycount=#objecttable(loooser.soldier_pistol.object.id)+#objecttable(loooser.soldier_mg.object.id)+#objecttable(loooser.soldier_sniper.object.id)+#objecttable(loooser.soldier_shotgun.object.id)+#objecttable(cc.strawdummy.id)+#objecttable(loooser.hostage.object.id)
    if enemycount==0 then
      countdown=countdown+1
      -- wait for hud msg
      if countdown>25 then
        win()
      end
    end
  end
  if countdown~=0 then
        cutscene()
  end
  --remove player by setting his position far away
  pl=playertable()
         for i = 1,#pl do
                 playerposition(pl[i],-10000,-10000)
         end
         level_update()
end

-- draw function
function mission_draw()

  level_draw()
  level_info()
end
-- draw info seperated to overite it in levels
function level_info()
  if countdown==0 then
    hudmsgbox("Kill all enemies with your heli!")
  else
    hudmsgbox("Good job! Mission complete!")
  end
end
-- seperated start function
function level_start()
end

function level_update()
end


function level_draw()
end

-- shield generator replacement
function removeshields(id)
        -- Remove all Shields
        shields=objecttable()
        for i=1,#shields do
                --Is Shield?
                local typ=getobjecttype(shields[i])
                if typ>=cc.shieldgen.shield0.id and typ<=cc.shieldgen.shield3.id then
                                --Remove FX
                                particle(p_muzzle,getobjectx(shields[i]),getobjecty(shields[i]))
                                particlesize(1,1)
                                particlecolor(255,100,150)
                                particlealpha(0.8)
                                particlefadealpha(0.01)
                                for j=1,3 do
                                        particle(p_spark,getobjectx(shields[i])+math.random(-5,5),getobjecty(shields[i])+math.random(-5,5))
                                        particlecolor(255,100,150)
                                        particlealpha(0.5+math.random()*3.0)
                                        particlesize(0.8+math.random(2,6)*0.1,0.8+math.random(2,6)*0.1)
                                end
                                --Remove
                                removeobject(shields[i])
                end
        end
end

--heli update replacement
function helimove(id,fx,x,y)
                if objects[id].health<=0 then
                -- Cause damage
                arealdamage(x,y,120,60)
                -- Destroy terrain
                if inmission()==0 then
                 terrainexplosion(x,y,60,1)
                else
                terrainexplosion(x,y,60,3)
                playerdamage(playercurrent(),-1000)
                end
                -- Crater
                grey=math.random(0,40)
                if math.random(0,1)==1 then
                      terrainalphaimage(gfx_crater125,x,y,math.random(6,9)*0.1,grey,grey,grey)
                else
                      terrainalphaimage(gfx_crater150,x,y,math.random(6,9)*0.1,grey,grey,grey)
                end
                stopchannel(1) -- stoping heli rotor sound

                -- Removing Object
                removeobject(id)
                endturn()
                end
         -- restarting heli sound for an loop
         objects[id].sound=objects[id].sound-1
         if objects[id].sound==0 then
                  objects[id].sound=3*50
                  playsound(cc.heli.sfx_sound,1)
         end
         -- if player who started the heli dies then the heli ends
         if objects[id].player~=playercurrent() then
                objects[id].health=0
         end
         -- making the variable counting down
         if objects[id].brate>0 then
                 objects[id].brate=objects[id].brate-1
         end
         -- Control by player
         --movement left and right
         if keydown(key_up)==1 and objects[id].sy>-6 then
                  objects[id].sy=objects[id].sy-0.25
         elseif keydown(key_down)==1 and objects[id].sy<6 then
                  objects[id].sy=objects[id].sy+0.25
         else
                  if objects[id].sy>0 then
                          objects[id].sy=objects[id].sy-0.25
                  elseif objects[id].sy<0 then
                          objects[id].sy=objects[id].sy+0.25
                  end
         end
         -- movement up and down
         if keydown(key_left)==1 and objects[id].sx>-6 then
                  objects[id].sx=objects[id].sx-0.25
         elseif keydown(key_right)==1 and objects[id].sx<6 then
                  objects[id].sx=objects[id].sx+0.25
         else
                  if objects[id].sx>0 then
                          objects[id].sx=objects[id].sx-0.25
                  elseif objects[id].sx<0 then
                          objects[id].sx=objects[id].sx+0.25
                  end
         end
         -- on attack fire selected weapon
         if keydown(key_attack)==1 and objects[id].brate<=0 and weapon_timer==1 then
               objects[id].brate=5
               playsound(cc.heli.sfx_attack)
               local pid=createprojectile(cc.heli.bullet.id)
               projectiles[pid]={}
               -- Ignore Object
               projectiles[pid].ignore=id
               -- Set initial position of projectile
               projectiles[pid].x=x+objects[id].lastdir*-20
               projectiles[pid].y=y+20+math.abs(objects[id].sx)*5
               -- Set speed of projectile
               math.randomseed(objects[id].timer*12345)
               offset=-6.0+math.random()*12.0
               projectiles[pid].sx=math.sin(math.rad(-90*objects[id].lastdir+math.deg(objects[id].sx/8)+offset))*15.0
               projectiles[pid].sy=-math.cos(math.rad(-90*objects[id].lastdir+math.deg(objects[id].sx/8)+offset))*15.0
               -- Initial movement
               projectiles[pid].x=projectiles[pid].x-objects[id].lastdir*20
               cc.heli.bullet.move(pid)
               -- Effects
               particle(p_muzzle,projectiles[pid].x,projectiles[pid].y)
               particle(p_smoke,projectiles[pid].x,projectiles[pid].y)
               particlespeed(-0.2+math.random()*0.4+getwind()*10.0,-1.0+math.random()*0.6)
               particlefadealpha(0.005)
               particle(p_bullet,x+objects[id].lastdir*-30,y+20)
         elseif keydown(key_attack)==1 and objects[id].brate<=0 and weapon_timer==2 then
               objects[id].brate=40
               playsound(cc.heli.sfx_attack2)
               tid=createprojectile(cc.heli.rocket.id)
               projectiles[tid]={}
               -- Ignore collision with current player at beginning
               projectiles[tid].ignore=id
               -- Set initial position of projectile
               projectiles[tid].x=x+objects[id].lastdir*-10
               projectiles[tid].y=y+25+math.abs(objects[id].sx)*5
               -- Set Timer
               projectiles[tid].timer=15
               -- Initial movement
               projectiles[tid].rot=-90*objects[id].lastdir+math.deg(objects[id].sx/8)
               projectiles[tid].sx=objects[id].sx
               projectiles[tid].sy=objects[id].sy
               projectiles[tid].x=projectiles[tid].x-projectiles[tid].sx
               projectiles[tid].y=projectiles[tid].y-projectiles[tid].sy
         end
         -- Particle Tail
         if (fx==1) then
               if objects[id].health<50 and objects[id].frame==1 then
               particle(p_spark,x+20*objects[id].lastdir,y+25+math.abs(objects[id].sx)*-5)
               particlespeed(objects[id].lastdir,math.random(-2,2)*0.1)
               particlefadealpha(0.01)
               end
               particle(p_smoke,x+20*objects[id].lastdir,y+25+math.abs(objects[id].sx)*-5)
               particlespeed(objects[id].lastdir,math.random(-4,-1)*0.1)
               particlefadealpha(0.01)
         end

        -- Wind influence on speed
        --objects[id].sx=objects[id].sx+getwind()

        -- Move (in substep loop for optimal collision precision)
        msubt=math.ceil(math.max(math.abs(objects[id].sx),math.abs(objects[id].sy))/3)
        msubx=objects[id].sx/msubt
        msuby=objects[id].sy/msubt
        for i=1,msubt,1 do
                x=x+msubx
                y=y+msuby
                -- Collision
                if collision(cc.heli.gfx_heli[1],x,y,1,1,1,-1,id)==1 then
                        if terraincollision()==1 or objectcollision()>0 then
                           if getobjecttype(objectcollision())~=loooser.hostage.object.id then
                                objects[id].health=0
                                break
                           end
                        else
                        playerdamage(playercollision(),-1000)
                        end
                end
                -- Water
                if y>getwatery() then
                        -- Effects
                        particle(p_waterhit,x,y)
                        playsound(sfx_hitwater1)
                        stopchannel(1)
                        -- Free projectile
                        if inmission()==1 then
                                  playerdamage(playercurrent(),-1000)
                        end
                        removeobject(id)
                        -- End Turn
                        endturn()
                        break
                end
        end
        -- Timer / Explode
        if (fx==1) then
                objects[id].timer=objects[id].timer-1
        end
        if objects[id].timer<=0 then
                 if inmission()==0 then
                objects[id].health=0
                end
        end
        -- Scroll to projectile
        scroll(x,y)
        objectposition(id,x,y)
end

--heli damage replacement
function helidamage(id,damage)
         if objects[id].health>0 then
                objects[id].health=objects[id].health-damage
                if inmission()==1 then
                         playerdamage(objects[id].player,(damage/150)*100)
                end
         end
end

function bulletmove(id)
        rot=math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy))
        -- Move (in substep loop for optimal collision precision)
        msubt=math.ceil(math.max(math.abs(projectiles[id].sx),math.abs(projectiles[id].sy))/3)
        msubx=projectiles[id].sx/msubt
        msuby=projectiles[id].sy/msubt
        for i=1,msubt,1 do
                projectiles[id].x=projectiles[id].x+msubx
                projectiles[id].y=projectiles[id].y+msuby
                -- Collision
                if collision(col3x3,projectiles[id].x+math.sin(math.rad(rot))*20,projectiles[id].y-math.cos(math.rad(rot))*20,1,1,1,-1,projectiles[id].ignore)==1 then
                        -- Cause damage
                        if playercollision()~=0 then
                                playerpush(playercollision(),projectiles[id].sx/10.0,projectiles[id].sy/10.0)
                                playerdamage(playercollision(),5)
                                blood(projectiles[id].x+math.sin(math.rad(rot))*20,projectiles[id].y-math.cos(math.rad(rot))*20)
                        elseif objectcollision()>0 then
                                objectdamage(objectcollision(),5)
                        end
                        -- Destroy terrain
                        if inmission()==0 then
                        for j=20,22,1 do
                                terraincircle(projectiles[id].x+math.sin(math.rad(rot))*j,projectiles[id].y-math.cos(math.rad(rot))*j,3,0x00000000)
                        end
                        end
                        -- Effects
                        playsound(sfx_ricochet1)
                        particle(p_smoke,projectiles[id].x+math.sin(math.rad(rot))*21,projectiles[id].y-math.cos(math.rad(rot))*21)
                        particlefadealpha(0.006)
                        particle(p_muzzle,projectiles[id].x+math.sin(math.rad(rot))*21,projectiles[id].y-math.cos(math.rad(rot))*21)
                        -- Free projectile
                        freeprojectile(id)
                        return 1
                end
                -- Water
                if (projectiles[id].y)>getwatery()+5 then
                        -- Effects
                        particle(p_waterhit,projectiles[id].x,projectiles[id].y)
                        if math.random(1,2)==1 then
                                playsound(sfx_hitwater2)
                        else
                                playsound(sfx_hitwater3)
                        end
                        -- Free projectile
                        freeprojectile(id)
                        return 1
                end
        end
end

function rocketmove(id,fx)
        rot=projectiles[id].rot
        -- Particle Tail
        if (fx==1) and projectiles[id].timer<0 then
                particle(p_smoke,projectiles[id].x-math.sin(math.rad(rot))*7,projectiles[id].y+math.cos(math.rad(rot))*7)
                particlespeed(math.random(-2,2)*0.1,math.random(-2,2)*0.1)
                particlefadealpha(0.01)
        end

        if (fx==1) then
                projectiles[id].timer=projectiles[id].timer-1
        end
                if projectiles[id].timer<=0 and projectiles[id].timer>-250 then

                if projectiles[id].timer==0 then
                end
                speed=math.sqrt(math.pow(projectiles[id].sx,2)+math.pow(projectiles[id].sy,2))
                if speed<16.0 then
                        speed=speed+0.15
                        if speed>16.0 then speed=16.0 end
                end
                projectiles[id].sx=math.sin(math.rad(rot))*speed
                projectiles[id].sy=2-math.cos(math.rad(rot))*speed
        end
        -- Wind + Gravity influence on speed
        projectiles[id].sx=projectiles[id].sx+getwind()
        projectiles[id].sy=projectiles[id].sy+getgravity()
        -- Move (in substep loop for optimal collision precision)
        msubt=math.ceil(math.max(math.abs(projectiles[id].sx),math.abs(projectiles[id].sy))/3)
        msubx=projectiles[id].sx/msubt
        msuby=projectiles[id].sy/msubt
        for i=1,msubt,1 do
                projectiles[id].x=projectiles[id].x+msubx
                projectiles[id].y=projectiles[id].y+msuby
                -- Collision
                if collision(col3x3,projectiles[id].x+math.sin(math.rad(rot))*3,projectiles[id].y-math.cos(math.rad(rot))*3)==1 or explode==1 then
                        if terraincollision()==1 or objectcollision()~=projectiles[id].ignore or playercollision()>0 then
                                -- Cause damage
                                arealdamage(projectiles[id].x,projectiles[id].y,100,20)
                                -- Destroy terrain
                                if inmission()==0 then
                                terrainexplosion(projectiles[id].x,projectiles[id].y,25,1)
                                else
                                terrainexplosion(projectiles[id].x,projectiles[id].y,25,3)
                                end
                                -- Crater
                                grey=math.random(0,40)
                                if math.random(0,1)==1 then
                                        terrainalphaimage(gfx_crater100,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
                                else
                                        terrainalphaimage(gfx_crater125,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
                                end
                                -- Free projectile
                                freeprojectile(id)
                                break
                        end
                else
                        projectiles[id].ignore=0
                end
                -- Water
                if (projectiles[id].y)>getwatery()+5 then
                        -- Effects
                        particle(p_waterhit,projectiles[id].x,projectiles[id].y)
                        playsound(sfx_hitwater1)
                        -- Free projectile
                        freeprojectile(id)
                        break
                end
        end
end